<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_CommonPriceBreakdown1 ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_CommonPriceBreakdown1 extends AbstractStructArrayBase
{
    /**
     * The Commission
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_CommonPriceBreakdown[]
     */
    public $Commission;
    /**
     * Constructor method for ArrayOfJP_CommonPriceBreakdown1
     * @uses ArrayOfJP_CommonPriceBreakdown1::setCommission()
     * @param \StructType\JP_CommonPriceBreakdown[] $commission
     */
    public function __construct(array $commission = array())
    {
        $this
            ->setCommission($commission);
    }
    /**
     * Get Commission value
     * @return \StructType\JP_CommonPriceBreakdown[]|null
     */
    public function getCommission()
    {
        return $this->Commission;
    }
    /**
     * Set Commission value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CommonPriceBreakdown[] $commission
     * @return \ArrayType\ArrayOfJP_CommonPriceBreakdown1
     */
    public function setCommission(array $commission = array())
    {
        foreach ($commission as $arrayOfJP_CommonPriceBreakdown1CommissionItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_CommonPriceBreakdown1CommissionItem instanceof \StructType\JP_CommonPriceBreakdown) {
                throw new \InvalidArgumentException(sprintf('The Commission property can only contain items of \StructType\JP_CommonPriceBreakdown, "%s" given', is_object($arrayOfJP_CommonPriceBreakdown1CommissionItem) ? get_class($arrayOfJP_CommonPriceBreakdown1CommissionItem) : gettype($arrayOfJP_CommonPriceBreakdown1CommissionItem)), __LINE__);
            }
        }
        $this->Commission = $commission;
        return $this;
    }
    /**
     * Add item to Commission value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CommonPriceBreakdown $item
     * @return \ArrayType\ArrayOfJP_CommonPriceBreakdown1
     */
    public function addToCommission(\StructType\JP_CommonPriceBreakdown $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_CommonPriceBreakdown) {
            throw new \InvalidArgumentException(sprintf('The Commission property can only contain items of \StructType\JP_CommonPriceBreakdown, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Commission[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_CommonPriceBreakdown|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_CommonPriceBreakdown|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_CommonPriceBreakdown|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_CommonPriceBreakdown|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_CommonPriceBreakdown|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Commission
     */
    public function getAttributeName()
    {
        return 'Commission';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_CommonPriceBreakdown1
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
